// Generated by CoffeeScript 1.7.1
(function() {
  var EnvToJson, exec, unflatten;

  exec = require("child_process").exec;

  unflatten = require('flat').unflatten;

  EnvToJson = (function() {
    function EnvToJson(ignore) {
      this.ignore = ignore;
      if (this.ignore == null) {
        this.ignore = ["PWD", "SHLVL", "_"];
      }
    }

    EnvToJson.prototype.nested = function(flat, filter) {
      var key, lowerEnv, nested, val;
      lowerEnv = {};
      for (key in flat) {
        val = flat[key];
        lowerEnv[key.toLowerCase()] = val;
      }
      nested = unflatten(lowerEnv, {
        delimiter: "_"
      });
      if (filter) {
        return nested[filter.toLowerCase()];
      }
      return nested;
    };

    EnvToJson.prototype.capture = function(file, cb) {
      var cmd, flat, options, stderr, stdout;
      stdout = [];
      stderr = [];
      flat = {};
      options = {
        env: {}
      };
      return cmd = exec("source " + file + " && env", options, (function(_this) {
        return function(err, stdout, stderr) {
          var item, key, parts, val, _i, _len, _ref;
          if (err) {
            return cb("Error while running " + file + ". " + err + ". " + stderr);
          }
          _ref = stdout.split("\n");
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            item = _ref[_i];
            parts = item.split("=");
            key = parts.shift();
            val = parts.join("=");
            if (_this.ignore.indexOf(key) !== -1 || !key) {
              continue;
            }
            flat[key] = val;
          }
          return cb(null, flat);
        };
      })(this));
    };

    return EnvToJson;

  })();

  module.exports = EnvToJson;

}).call(this);
